{% extends "baseAjaxTable.html" %}
{% block style %}
{% endblock %}
{% block content %}
{% if current_user.est_moniteur() %}
<button  data-toggle="modal" class="btn btn-danger btn-del" data-target="#modalSupprimer">Supprimer la ligne</button>
<button type="button"  data-target="#ModalReservationForm" class="btn btn-secondary btn-add" data-toggle="modal" >Ajouter une Reservation</button>
<button type="button" class="btn btn-secondary btn-edit" data-toggle="modal" data-target="#ModalModifReservationForm"> Modifier la Reservation</button>
{% else %}
<button type="button"  data-target="#ModalReservationForm" class="btn btn-secondary btn-add" data-toggle="modal" >Reserver</button>
{% endif %}
<button type="button" id="btn-filtre" class="btn btn-secondary" data-toggle="modal" data-target="#ModalReservationFormFiltre"> Filtrer</button>

  <table id="data" class="table table-striped display table-bordered">
    <thead>
      <tr>
        <th>ID Cours</th>
        <th>ID Client</th>
        <th>Nom Client</th>
        <th>Nom Cours</th>
        <th>Date Cours</th>
        <th>ID Poney</th>
        <th>Nom Poney</th>
        <th>Nom Moniteur</th>
        
      </tr>
    </thead>
    <tbody>

    </tbody>
  </table>
  <!--Modal s'affichant lors du clique de supprimer pour savoir si on veut vraiment supprimer-->
  <div class="modal fade" id="modalSupprimer" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Supprimer</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <p>Etes-vous sur de vouloir supprimer cette reservation ?</p>
          <span id="reservationsup"></span>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
          <button type="button" class="btn btn-danger" id="deleteReservation" data-dismiss="modal">Supprimer</button>
          
        </div>
      </div>
    </div>
</div>

 
<div id="ModalReservationForm" class="modal fade modal-reservation" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
            {% if current_user.est_moniteur() %}
              <h1 class="modal-title">Ajouter une reservation</h1>
            {% else %}
            <h1 class="modal-title">Reserver</h1>
            {% endif %}
          </div>
          <div class="modal-body">
            {% if not current_user.est_moniteur() %}
            <h3>Le prix d'une résérvation est fixée à 20€</h3>
            {% endif %}
              <form role="form" method="POST", action="{{url_for('save_reservation')}}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="submit" class="btn btn-primary" value="Ajouter">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->


<div id="ModalModifReservationForm" class="modal fade modal-reservation" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Modifier la Reservation</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{url_for('edit_reservation')}}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% elif form[field].type == 'BooleanField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} "">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="hidden" id="ancien_nom_prenom_client" name="ancien_nom_prenom_client">
                <input type="hidden" id="ancien_nom_cours" name="ancien_nom_cours">
                <input type="hidden" id="ancien_date_reservation" name="ancien_date_reservation">
                <input type="hidden" id="ancien_nom_poney" name="ancien_nom_poney">
                <input type="submit" class="btn btn-primary" value="Modifier">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->


<div id="ModalReservationFormFiltre" class="modal fade modal-reservation" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Filtrer</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST">
                {{ form.hidden_tag() }}
                {% for field in form_filtre.get_form_field() %}
                    {% if form_filtre[field].type == 'SelectField' %}
                      <div class="form-group{% if form_filtre[field].errors %} has-error{% endif %}">
                        {{ form_filtre[field].label }} {{ form_filtre[field](size=1) }}
                      </div>
                    {% else %}
                      <div class="form-group{% if form_filtre[field].errors %} has-error{% endif %}">
                            {{ form_filtre[field].label }} {{ form_filtre[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form_filtre[field].errors %}
                        <ul class="list-group">
                            {% for e in form_filtre[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <button type="button" id="btn-filtre-save" class="btn btn-secondary" data-toggle="modal" data-target="#ModalReservationFormFiltre"> Filtrer</button>
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->
{% endblock %}

{% block scripts %}
  <script>
    
    
    let row = null;
    $(document).ready(function(){
      let open_modal = '{{open_modal}}';
      if (open_modal) {
        $('#ModalReservationForm').modal('show');
      }
      let open_modal_edit = '{{open_modal_edit}}';
      if (open_modal_edit) {
        $('#ModalModifReservationForm').modal('show');
      }

      $(".btn-edit").prop("disabled",true);
      $(".btn-del").prop("disabled",true);
      
      let table = $('#data').DataTable({
        ajax:{
          url:'/api/data/reservation',
                type:"POST",
                data:function(reserv){
                    if(reserv!=undefined){
                      reserv.nom_prenom_client_filtre = $("#nom_prenom_client_filtre").val();
                      reserv.nom_cours_filtre = $("#nom_cours_filtre").val();
                      reserv.date_reservation_filtre = $("#date_reservation_filtre").val();
                      reserv.nom_poney_filtre = $("#nom_poney_filtre").val();
                  }
                  return reserv
                }
        },
        columns: [
          {data: 'idc', orderable:true},
          {data: 'id_cl', searchable: true, orderable:true},
          {data: 'prenom_nom_client', searchable: true, orderable:true},
          {data: 'nom_cours', searchable: true, orderable:true},
          {data: 'date_cours', searchable: true, orderable:true},
          {data: 'idpo', searchable: true, orderable:true},
          {data: 'nom_poney', searchable: true, orderable:true},
          {data: 'prenom_nom_moniteur', searchable: true, orderable:true}
        ],
      
        
      });

      $("#nom_prenom_client").change(function() {
      let optionToDisable = document.querySelector("#nom_prenom_client")[0];
      optionToDisable.disabled = true;
      });

      $("#nom_cours").change(function() {
        console.log("oco");
        console.log($('#ModalReservationForm #nom_cours').val());
        let optionToDisable = document.querySelector("#nom_cours")[0];
        optionToDisable.disabled = true;
      });

      $("#date_reservation, #nom_cours, #nom_prenom_client").change(function() {
        let selectedValueDate = $("#date_reservation").val();
        let selectedValueClient = $("#nom_prenom_client").val();
        let selectedValueCours = $("#nom_cours").val();
        if(selectedValueCours != "None" && selectedValueClient != "None" && selectedValueDate != ""){
          // ici vous pouvez utiliser la valeur sélectionnée pour mettre à jour les options du deuxième Select Field
          // par exemple en utilisant une requête AJAX pour récupérer les nouvelles options depuis un serveur
          $.ajax({
            url: '/update_poney_options',
            type: 'POST',
            data: {'client_id': selectedValueClient, 'date_reservation':selectedValueDate, 'cours_id':selectedValueCours},
            success: function(response) {
                let options = "";
                response.forEach(poney => {
                  options += `<option value=${poney.id}>id ${poney.id}: ${poney.name}</option>`;

                });
                $("#nom_poney").html(options);
            },
            error: function(error) {
              console.log(error);
            }
          });
        }
      });

      $('#ModalModifReservationForm input, #ModalModifReservationForm select, #ModalModifReservationForm textarea').each(function(){
            let currentId = $(this).attr('id');
            $(this).attr('id', currentId + '_modif');
        });


       $("#data").on("click", "tr", function() {
            if(row !=null){
                $(row).css('background-color', "");     
            }
            row = this;
            $(".btn-edit").prop("disabled",false);
            $(".btn-del").prop("disabled",false);
            $(this).css('background-color', "#AFE1AF");
            $("#reservationsupprimer").html($(row)[0].childNodes[1].innerHTML+ " " + $(row)[0].childNodes[2].innerHTML)
        });

        $("#deleteReservation").on("click",function(){
          
            $.ajax({
                url:'{{url_for("delete_reservation")}}',
                type:'POST',
                data:{date_c:$(row)[0].childNodes[4].innerHTML,id_cl:$(row)[0].childNodes[1].innerHTML,id_c:$(row)[0].childNodes[0].innerHTML},
            success: function(){
                table.ajax.reload();
                } 
            });       
        });

        $('#nom_prenom_client').select2({  // init Select2 on form's name field
          dropdownParent: $('#ModalReservationForm'),
          placeholder: "{{ form.nom_prenom_client.label.text }}",
          allowClear: true,
          "width": "style"
        });

        $('#nom_cours').select2({  // init Select2 on form's name field
          dropdownParent: $('#ModalReservationForm'),
          placeholder: "{{ form.nom_cours.label.text }}",
          allowClear: true,
          "width": "style"
        });

        $('#nom_poney').select2({  // init Select2 on form's name field
          dropdownParent: $('#ModalReservationForm'),
          placeholder: "{{ form.nom_poney.label.text }}",
          allowClear: true,
          "width": "style"
        });
     
        $('#nom_prenom_client_modif').select2({  // init Select2 on form's name field
          dropdownParent: $('#ModalModifReservationForm'),
          placeholder: "{{ form.nom_prenom_client.label.text }}",
          allowClear: true,
          "width": "style"
        });

        $('#nom_cours_modif').select2({  // init Select2 on form's name field
          dropdownParent: $('#ModalModifReservationForm'),
          placeholder: "{{ form.nom_cours.label.text }}",
          allowClear: true,
          "width": "style"
        });

        $('#nom_poney_modif').select2({  // init Select2 on form's name field
          dropdownParent: $('#ModalModifReservationForm'),
          placeholder: "{{ form.nom_poney.label.text }}",
          allowClear: true,
          "width": "style"
        });

        $(document).on('click', '.btn-edit', function() {
          // On récuperer les heures dans les input de type time et on les convertie dans le bon format.

          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation

          $('#ModalModifReservationForm #nom_cours_modif').val($(row)[0].childNodes[0].innerHTML);
          $('#ModalModifReservationForm #nom_prenom_client').val($(row)[0].childNodes[1].innerHTML);
          $('#ModalModifReservationForm #date_reservation').val($(row)[0].childNodes[4].innerHTML);
          $('#ModalModifReservationForm #nom_poney').val($(row)[0].childNodes[5].innerHTML);

          $('#ModalModifReservationForm #ancien_nom_cours_modif').val($(row)[0].childNodes[0].innerHTML);
          $('#ModalModifReservationForm #ancien_nom_prenom_client_modif').val($(row)[0].childNodes[1].innerHTML);
          $('#ModalModifReservationForm #ancien_date_reservation_modif').val($(row)[0].childNodes[4].innerHTML);
          $('#ModalModifReservationForm #ancien_nom_poney_modif').val($(row)[0].childNodes[5].innerHTML);


          // Afficher le modal
          $('#ModalModifReservationForm').modal('show');
        });

        $("#data").on("dblclick", "tr", function() {
          row = this;
          let dateReservation = row.childNodes[4].innerHTML;
          let idCour = row.childNodes[0].innerHTML;
          let idClient = row.childNodes[1].innerHTML;
          window.location.href = "{{ url_for('detail_reservation', date_c='dateReservation', idcl='idClient', idc='idCour') }}".replace("idCour",idCour).replace("idClient",idClient).replace("dateReservation",dateReservation) ;
        });

        $(document).on('click', '.btn-add', function() {
          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation

          $('#ModalReservationForm #date_reservation').val("");
          $('#ModalReservationForm #nom_cours option[value="None"]').prop('selected', true);
          $('#ModalReservationForm #nom_prenom_client option[value="None"]').prop('selected', true);
          $('#ModalReservationForm #nom_poney option[value="None"]').prop('selected', true);
          $('#ModalReservationForm #nom_cours').change();
          $('#ModalReservationForm #nom_prenom_client').change();
          $('#ModalReservationForm #nom_poney').change();

          $('#ModalReservationForm').modal('show');

          let errorElements = document.getElementsByClassName("list-group-item-danger");

          // Loop through the elements and remove the li element
          while(errorElements.length > 0){
            errorElements[0].parentNode.removeChild(errorElements[0]);
          }
          
        });
        $("#btn-filtre-save").on("click",function(){
          table.ajax.reload();
          $("#ModalReservationFormFiltre").modal("hide");
        });
        $("#btn-filtre").on("click",function(){
            $("#ModalReservationFormFiltre").modal("show");
        });

    });

    /*request.form["date_c"], request.form["id_cl"], request.form["id_c"]*/

   
 



    
  </script>
{% endblock %}
<!--
  https://datatables.net/examples/api/select_single_row.html
  https://blog.miguelgrinberg.com/post/beautiful-interactive-tables-for-your-flask-templates-->